//+------------------------------------------------------------------+
//|                                                  IINMA-Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double TakeProfit     = 0;
extern double Lots           = 0.1;
extern double TrailingStop   = 0;

extern int    FasterMode     =3; //0=sma, 1=ema, 2=smma, 3=lwma
extern int    FasterMA       =3;
extern int    SlowerMode     =3; //0=sma, 1=ema, 2=smma, 3=lwma
extern int    SlowerMA       =3;

datetime      timeprev        =0;

double pointvalue;

int init() 
{
    //Convert to 3 & 5 diget broker
    if (Digits == 4 || Digits == 2) pointvalue = Point;
      else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   // Only run once per completed bar L-118
     if(timeprev==Time[0]) return(0);
     timeprev = Time[0];
   
   int cnt, ticket, total;
   int limit, i, counter;
   double fasterMAnow, slowerMAnow, fasterMAprevious, slowerMAprevious, fasterMAafter, slowerMAafter;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
//----
   limit=Bars-counted_bars;
     for(i=0; i<=limit; i++) 
     {
      counter=i;
      Range=0;
      AvgRange=0;
      for(counter=i ;counter<=i+9;counter++)
        {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
        }
      Range=AvgRange/10;
      fasterMAnow=iMA(NULL, 0, FasterMA, 0, FasterMode, PRICE_CLOSE, i);
      fasterMAprevious=iMA(NULL, 0, FasterMA, 0, FasterMode, PRICE_CLOSE, i+1);
      fasterMAafter=iMA(NULL, 0, FasterMA, 0, FasterMode, PRICE_CLOSE, i-1);
//---- L-60
      slowerMAnow=iMA(NULL, 0, SlowerMA, 0, SlowerMode, PRICE_OPEN, i);
      slowerMAprevious=iMA(NULL, 0, SlowerMA, 0, SlowerMode, PRICE_OPEN, i+1);
      slowerMAafter=iMA(NULL, 0, SlowerMA, 0, SlowerMode, PRICE_OPEN, i-1);
     
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
         }
      // check for long position (BUY) possibility
      if ((fasterMAnow > slowerMAnow) && (fasterMAprevious < slowerMAprevious) &&
       (fasterMAafter > slowerMAafter)) 
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"IINWMA",16384,0,Green);
          if(ticket>0)
          {
             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
          }
            
           /*if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
            {
            OrderModify(ticket,OrderOpenPrice(),Ask+TakeProfit*pointvalue,0,0,CLR_NONE);
            Print("BUY order opened : ", OrderOpenPrice());
            }*/
          else
         Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
       }
     return(0);
     }  
      // check for short position (SELL) possibility
      if ((fasterMAnow < slowerMAnow) && (fasterMAprevious > slowerMAprevious) && 
      (fasterMAafter < slowerMAafter)) 
       {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"IINWMA",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
                       
           /* if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            {/*
             OrderModify(ticket,OrderOpenPrice(),Bid-TakeProfit*pointvalue,0,0,CLR_NONE);          
             Print("SELL order opened : ", OrderOpenPrice());
           }*/
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      //return(0);
    // }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if ((fasterMAnow < slowerMAnow) && (fasterMAprevious > slowerMAprevious) && 
               (fasterMAafter < slowerMAafter))
      //if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious &&
        //       MacdCurrent>(MACDCloseLevel*pointvalue))
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>pointvalue*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-pointvalue*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-pointvalue*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if ((fasterMAnow > slowerMAnow) && (fasterMAprevious < slowerMAprevious) &&
               (fasterMAafter > slowerMAafter)) 
            //if(MacdCurrent<0 && MacdCurrent>SignalCurrent &&
               //MacdPrevious<SignalPrevious && MathAbs(MacdCurrent)>(MACDCloseLevel*pointvalue))
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(pointvalue*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+pointvalue*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+pointvalue*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.